unit FormMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ExtCtrls, Menus, StdCtrls, ImgList, Buttons, Spin, ShellAPI,
  math3d, {$IfDef HELIOS_APP}Helios_Engine, Helios_Global, Helios_MD3_Engine,
  SynEditHighlighter, SynUniHighlighter, CheckLst, SynEdit, jpeg{$Else}Helios_Basic{$EndIf},
  UnitMD5,Helios_Shader_System,
  jpeg, SynEdit, SynEditHighlighter, SynUniHighlighter, CheckLst;

Const
APPLICATION_TITLE = 'Project Helios: Model Viewer';
APPLICATION_VER = '2.0';
APPLICATION_BY = 'Stucuk';

type
  TFrmMain = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    Panel1: TPanel;
    StatusBar1: TStatusBar;
    MainView: TPanel;
    Help1: TMenuItem;
    About1: TMenuItem;
    ColorDialog: TColorDialog;
    ools1: TMenuItem;
    BackgroundColour2: TMenuItem;
    Options1: TMenuItem;
    Disable3DView1: TMenuItem;
    TopBarImageHolder: TImage;
    Label3: TLabel;
    Label21: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    Panel2: TPanel;
    ModBox: TComboBox;
    Label1: TLabel;
    LoadModel1: TMenuItem;
    N2: TMenuItem;
    OpenModelDialog: TOpenDialog;
    Panel3: TPanel;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    ModelInfo: TRichEdit;
    Label2: TLabel;
    DrawBonesCheck: TCheckBox;
    BoneColourPanel: TPanel;
    Label4: TLabel;
    BoneSizeSE: TSpinEdit;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    NormalsCheck: TCheckBox;
    Label8: TLabel;
    ShowTanCheck: TCheckBox;
    Label9: TLabel;
    TrackBar5: TTrackBar;
    TrackBar6: TTrackBar;
    TrackBar7: TTrackBar;
    Label11: TLabel;
    TrackBar1: TTrackBar;
    BumpMapCheckBox: TCheckBox;
    Label10: TLabel;
    ShaderBox: TComboBox;
    SynEdit1: TSynEdit;
    SynUniSyn: TSynUniSyn;
    TabSheet4: TTabSheet;
    VisibleMeshs: TCheckListBox;
    Label12: TLabel;
    Label13: TLabel;
    TextureCheckBox: TCheckBox;
    Label14: TLabel;
    procedure Exit1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Idle(Sender: TObject; var Done: Boolean);
    procedure MainViewMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure MainViewMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure MainViewMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    Procedure SetCaption(Filename : String);
    Procedure SetIsEditable;
    procedure MainViewResize(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure BackgroundColour2Click(Sender: TObject);
    procedure Disable3DView1Click(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    Procedure GetModList;
    procedure ModBoxChange(Sender: TObject);
    procedure LoadModel1Click(Sender: TObject);
    procedure DrawBonesCheckClick(Sender: TObject);
    procedure BoneColourPanelClick(Sender: TObject);
    procedure BoneSizeSEChange(Sender: TObject);
    procedure NormalsCheckClick(Sender: TObject);
    procedure ShowTanCheckClick(Sender: TObject);
    procedure TrackBar6Change(Sender: TObject);
    procedure TrackBar5Change(Sender: TObject);
    procedure TrackBar7Change(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure BumpMapCheckBoxClick(Sender: TObject);
    procedure ShaderBoxChange(Sender: TObject);
    procedure VisibleMeshsClickCheck(Sender: TObject);
    procedure TextureCheckBoxClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    ModelFilename : String;
    Loading : Boolean;
  end;

var
  FrmMain: TFrmMain;

implementation

uses FormAboutNew,ThreeDView_Engine;

{$R *.dfm}

procedure TFrmMain.Exit1Click(Sender: TObject);
begin
Close;
end;

procedure TFrmMain.Idle(Sender: TObject; var Done: Boolean);
begin
if (not MVEnabled) or (not ModelLoaded) then exit;

DrawFrames;

Done := false;
end;

procedure TFrmMain.FormCreate(Sender: TObject);
begin
Loading := True;
SetCaption('');
PageControl1.ActivePage := TabSheet1;
TabSheet4.TabVisible := False;
MainViewWidth := MainView.Width;
MainViewHeight := MainView.Height;

If fileexists(ExtractFileDir(ParamStr((0))) + '\Q3Shader.HGL') then
SynUniSyn.LoadFromFile(ExtractFileDir(ParamStr((0))) + '\Q3Shader.HGL')
else
begin
MessageBox(0,'Q3Shader.hgl not found','Missing File',0);
Close;
end;

Application.OnIdle := Idle;
Init(MainView.Handle);

GetModList;
SetIsEditable;

BoneColourPanel.Color := TVector3fToTColor(BoneColour);
BoneSizeSE.Value := BPS;
NormalsCheck.Checked := MD5Normals;
DrawBonesCheck.Checked := RenderMD5Bones;
ShowTanCheck.Checked := MD5ShowTangents;
Loading := False;
TrackBar6.Position := TrackBar6.Max;
{$IfDef HELIOS_APP}
TrackBar1.Position := -Trunc(Camera.Model_Position.Y);
{$Else}
TrackBar1.Position := -Trunc(ModelHeight);
{$EndIf}
end;

procedure TFrmMain.MainViewMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
if (not MVEnabled) then exit;

  if Button = mbLeft  then
  begin
    MouseButton :=1;
    Xcoord := X;
    Ycoord := Y;
  end;
  if Button = mbRight then
  begin
    MouseButton :=2;
    Zcoord := Y;
  end;
end;

procedure TFrmMain.MainViewMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  if MouseButton = 1 then
  begin
   {$IfDef HELIOS_APP}
   if Camera.ModelMode then
   begin

    xRot := Camera.Model_x_angle;
    yRot := Camera.Model_y_angle;
    xRot := xRot + (Y - Ycoord)/2;  // moving up and down = rot around X-axis
    yRot := yRot + (X - Xcoord)/2;
    Camera.Model_y_angle := YRot;
    Camera.Model_x_angle := XRot;
    Xcoord := X;
    Ycoord := Y;

   end
   else {$EndIf}
   begin
    {$IfDef HELIOS_APP}
    xRot := Camera.x_angle;
    yRot := Camera.y_angle;
    {$EndIf}
    xRot := xRot + (Y - Ycoord)/2;  // moving up and down = rot around X-axis
    yRot := yRot + (X - Xcoord)/2;
    {$IfDef HELIOS_APP}
    Camera.y_angle := YRot;
    Camera.x_angle := XRot;
    {$EndIf}
    Xcoord := X;
    Ycoord := Y;
   end;
  end;
  if MouseButton = 2 then
  begin
  {$IfDef HELIOS_APP}if Camera.ModelMode then{$EndIf}
  begin
    {$IfDef HELIOS_APP}Depth := Camera.Model_Depth;{$EndIf}
    Depth :=Depth - (Y-ZCoord)/3;
    {$IfDef HELIOS_APP}Camera.Model_Depth := Depth;{$EndIf}
    Zcoord := Y;
  end;
  end;
end;

procedure TFrmMain.MainViewMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  MouseButton :=0;
  MainView.Cursor := crCross;
end;

Procedure TFrmMain.SetCaption(Filename : String);
begin

If Filename <> '' then
Caption := ' ' + APPLICATION_TITLE + ' v'+APPLICATION_VER + ' [' +Extractfilename(Filename) + ']'
else
Caption := ' ' + APPLICATION_TITLE + ' v'+APPLICATION_VER;

end;

Procedure TFrmMain.SetIsEditable;
var
Value : Boolean;
begin
Value := ModelLoaded;

ools1.Visible := Value;
Options1.Visible := Value;

ShaderBox.Enabled := Value;
ModelInfo.Enabled := Value;
//PageControl1.Enabled := Value;

DrawBonesCheck.Enabled := False;
BoneColourPanel.Enabled := False;
BoneSizeSE.Enabled := False;
NormalsCheck.Enabled := False;
ShowTanCheck.Enabled := False;

If Value and (ModelType = 2) then
begin
DrawBonesCheck.Enabled := True;
BoneColourPanel.Enabled := True;
BoneSizeSE.Enabled := True;
NormalsCheck.Enabled := True;
ShowTanCheck.Enabled := True;
end;

Label4.Enabled := DrawBonesCheck.Enabled;
Label5.Enabled := DrawBonesCheck.Enabled;
Label6.Enabled := DrawBonesCheck.Enabled;
Label8.Enabled := DrawBonesCheck.Enabled;
Label9.Enabled := DrawBonesCheck.Enabled;

if Value then
MainView.Cursor := crCross
else
MainView.Cursor := crDefault;

end;

procedure TFrmMain.MainViewResize(Sender: TObject);
begin
if oglloaded then
ResizeMainView(MainView.Width,MainView.Height);
end;

procedure TFrmMain.About1Click(Sender: TObject);
var
  frm: TFrmAbout_New;
begin
  frm:=TFrmAbout_New.Create(Self);
  frm.Visible:=False;
  Frm.Image1.Picture := TopBarImageHolder.Picture;
  frm.Label2.Caption := APPLICATION_TITLE + ' v' + APPLICATION_VER;
  frm.label1.Caption := frm.label1.Caption + APPLICATION_BY;
  frm.ShowModal;
  frm.Close;
  frm.Free;
end;

procedure TFrmMain.BackgroundColour2Click(Sender: TObject);
begin
ColorDialog.Color := TVector3fToTColor(BGColor);
if ColorDialog.Execute then
BGColor := TColorToTVector3f(ColorDialog.Color);
end;

procedure TFrmMain.Disable3DView1Click(Sender: TObject);
begin
MVEnabled := not MVEnabled;
Disable3DView1.Checked := not MVEnabled;

if not MVEnabled then // no point refreshing if opengl is on
MainView.Refresh;
end;

procedure TFrmMain.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
{$IfDef HELIOS_APP}
keys[Key] := False;
{$EndIf}
//Cons.EvalKeys(Keys);
end;

procedure TFrmMain.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
//if char(key) = '\' then
//showmessage(inttostr(Key));
{$IfDef HELIOS_APP}
keys[Key] := True;
lastKeyPress := GetTickCount;
{$EndIf}

{w=87
s=63    }
end;

procedure TFrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
{$IfDef HELIOS_APP}
DestroyHelios;
{$EndIf}
end;

Procedure TFrmMain.GetModList;
var
f: TSearchRec;
x : integer;
begin

ModBox.Items.Clear;

if FindFirst(extractfiledir(paramstr(0)) + '\*',faDirectory,f) = 0 then repeat

if DirectoryExists(extractfiledir(paramstr(0)) + '\' + f.Name) then
if fileexists(extractfiledir(paramstr(0)) + '\' + f.Name +'\liblist.gam') then
ModBox.Items.Add(f.Name);

until FindNext(f) <> 0;
FindClose(f);

ModBox.ItemIndex := 0;

if ModBox.Items.Count > 0 then
for x := 0 to ModBox.Items.Count -1 do
if ansilowercase(ModBox.Items.Strings[x]) = 'main' then
begin
ModBox.ItemIndex := x;
break;
end;

ChangeModFolder(ModBox.Text);

end;

procedure TFrmMain.ModBoxChange(Sender: TObject);
begin
ChangeModFolder(ModBox.Text);
SetCaption('');
end;

procedure TFrmMain.LoadModel1Click(Sender: TObject);
var
x,y : integer;
begin

If OpenModelDialog.Execute then
begin

ModelFilename := OpenModelDialog.filename;
ModelType := 0; // no model!
SetCaption('');
ModelLoaded := False;

ShaderBox.Clear;
ModelInfo.Clear;

{$IfDef HELIOS_APP}
If Ansilowercase(ExtractFileExt(OpenModelDialog.filename)) = '.md3' then
begin
ModelType := 1;

CheckModelMode;

DestroyHeliosSystems;
ShaderManager.RequiredShaders.Clear;
//CreateORDestroyMD3;
X := AddMd3ToList(ModelFilename);
If x = -1 then exit;


MD3List.Data[x].Draw := true;
MD3List.Data[x].Angles := SetVector(-90,0,180);

ModelInfo.Lines.Add('MD3 Version: ' + inttostr(MD3List.Data[x].Model.Header.Version));
ModelInfo.Lines.Add('NumMeshes: ' + inttostr(MD3List.Data[x].Model.Header.numMeshes));
ModelInfo.Lines.Add('NumBoneFrames: ' + inttostr(MD3List.Data[x].Model.Header.numBoneFrames));
ModelInfo.Lines.Add('NumMaxSkins: ' + inttostr(MD3List.Data[x].Model.Header.numMaxSkins));
ModelInfo.Lines.Add('NumTags: ' + inttostr(MD3List.Data[x].Model.Header.numTags));

for y := 0 to MD3List.Data[x].Model.Header.numMeshes-1 do
try
ShaderBox.items.Add(ShaderManager.GetTextureNameInShaderFormat(MD3List.Data[x].Model.Meshes[y].Skin));
except

end;

ShaderBox.ItemIndex := 0;
ShaderBoxChange(Sender);

VisibleMeshs.Items.Clear;
TabSheet4.TabVisible := False;

ShaderManager.ReadRequiredShaders;
MD3List.Data[x].Model.LoadTex; // reload model textures

ModelLoaded := True;
end
else {$EndIf}
If Ansilowercase(ExtractFileExt(OpenModelDialog.filename)) = '.md5mesh' then
begin
ModelType := 2;

{$IfDef HELIOS_APP}
CheckModelMode;

DestroyHeliosSystems;
{$EndIf}
ShaderManager.RequiredShaders.Clear;
ModelLoaded := LoadMD5(MD5,ModelFilename);

If ModelLoaded then
begin
ShaderManager.ReadRequiredShaders;

ModelInfo.Lines.Add('MD5Version: ' + inttostr(MD5.Header.MD5Version));
ModelInfo.Lines.Add('NumMeshes: ' + inttostr(MD5.Header.NumMeshes));
ModelInfo.Lines.Add('NumJoints: ' + inttostr(MD5.Header.NumJoints));

VisibleMeshs.Items.Clear;
TabSheet4.TabVisible := True;

for x := 0 to MD5.Header.NumMeshes-1 do
begin
ShaderBox.Items.Add(ShaderManager.GetTextureNameInShaderFormat(MD5.Meshs[x].Shader));
VisibleMeshs.Items.Add('Mesh ' + inttostr(x) + ' - ' + ShaderManager.GetTextureNameInShaderFormat(MD5.Meshs[x].Shader));
VisibleMeshs.Checked[x] := MD5.Meshs[x].Visible;
end;
end
else
exit;
end;

ShaderBox.ItemIndex := 0;
ShaderBoxChange(Sender);

SetIsEditable;
SetCaption(ModelFilename);
end;

end;

procedure TFrmMain.DrawBonesCheckClick(Sender: TObject);
begin
If Loading then exit;

RenderMD5Bones := not RenderMD5Bones;
DrawBonesCheck.Checked := RenderMD5Bones;
end;

procedure TFrmMain.BoneColourPanelClick(Sender: TObject);
begin
ColorDialog.Color := TVector3fToTColor(BoneColour);
If ColorDialog.Execute then
begin
BoneColour := TColorToTVector3f(ColorDialog.Color);
BoneColourPanel.Color := ColorDialog.Color;
end;
end;

procedure TFrmMain.BoneSizeSEChange(Sender: TObject);
begin
BPS := BoneSizeSE.Value;
end;

procedure TFrmMain.NormalsCheckClick(Sender: TObject);
begin
If Loading then exit;

MD5Normals := Not MD5Normals;
NormalsCheck.Checked := MD5Normals;
end;

procedure TFrmMain.ShowTanCheckClick(Sender: TObject);
begin
If Loading then exit;

MD5ShowTangents := Not MD5ShowTangents;
ShowTanCheck.Checked := MD5ShowTangents;
end;

procedure TFrmMain.TrackBar6Change(Sender: TObject);
begin
LightPos.X := TrackBar6.Position;
end;

procedure TFrmMain.TrackBar5Change(Sender: TObject);
begin
LightPos.Y := TrackBar5.Position;
end;

procedure TFrmMain.TrackBar7Change(Sender: TObject);
begin
LightPos.Z := TrackBar7.Position;
end;

procedure TFrmMain.TrackBar1Change(Sender: TObject);
begin
{$IfDef HELIOS_APP}
Camera.Model_Position.Y := -TrackBar1.Position;
{$Else}
ModelHeight := -TrackBar1.Position;
{$EndIf}
end;

procedure TFrmMain.BumpMapCheckBoxClick(Sender: TObject);
begin
UseBumpMaps := Not UseBumpMaps;
end;

procedure TFrmMain.ShaderBoxChange(Sender: TObject);
var
SID : Integer;
begin
If ShaderBox.Items.Count < 1 then exit;
SID := ShaderManager.FindShaderSrc(ShaderBox.Items[ShaderBox.ItemIndex]);
If SID = -1 then
begin
SynEdit1.Text := '--- SHADER NOT FOUND ---';
exit;
end;
SynEdit1.Text := ShaderManager.ShaderSrc[SID].Data;
end;

procedure TFrmMain.VisibleMeshsClickCheck(Sender: TObject);
var
x : integer;
begin

for x := 0 to MD5.Header.NumMeshes-1 do
MD5.Meshs[x].Visible := VisibleMeshs.Checked[x];

end;

procedure TFrmMain.TextureCheckBoxClick(Sender: TObject);
begin
MD5Textures := Not MD5Textures;
end;

end.
